// This uses the FFT to pick out the N
// highest peaks in the spectrum.
// (N=30 here, but you can define it)
// It drives a bank of SinOscs in a 
// mushy and interesting way
//
// Meanwhile, normal mic plus messed-up
// sines are capture in delay buffers
//
// As tilt forward/back controls it all

float SENSEX, SENSEY; FileIO config;  getConfig();

540 => float XMAX => float YMAX;

MAUI_View myWinder;
MAUI_Button score, capButt, endButt;
MAUI_LED dude; 
doGUI();

Hid hi;  HidMsg msg;
if( !hi.openTiltSensor() )  {
    <<< "tilt sensor unavailable", "" >>>;
    me.exit();
}

float theta,vx,vy,ax,ay;  // physics variables we might need
XMAX/2 => float x;  YMAX/2 => float y;  // more physics variables
0.80 => float DAMP;               // to control our "marble"

adc => Gain fftIn => FFT fft => blackhole;		// draw samples through FFT
0.0 => float fftGain;

Windowing.hamming(2048) => fft.window;
4096 => fft.size;
2048 => int halfsize;

UAnaBlob blob;
float peak,power;
int peakloc;

Std.mtof(41) => float funFreq;
5.0 => float harmStart;
30 => int N;
SinOsc s[N];
Gain sGains[N];
int bins[N];
int sbins[N];
float targs[N];
float freqs[N];
1.0 => float freqMult;

2.0 => float sinesGain;
Gain outMix => JCRev revL => dac.left;
     outMix => JCRev revR => dac.right;
Delay sparkleVerbL => revL;
Delay sparkleVerbR => revR;
sparkleVerbL => Gain LL => sparkleVerbL => Gain LR => sparkleVerbR;
sparkleVerbR => Gain RR => sparkleVerbR => Gain RL => sparkleVerbL;
0.3 => sparkleVerbL.gain => sparkleVerbR.gain;
0.314 :: second => sparkleVerbL.max => sparkleVerbL.delay;
0.411 :: second => sparkleVerbR.max => sparkleVerbR.delay;
0.03 => revL.mix => revR.mix;
0.0 => float tiltTarg;

adc => Gain inGain => Delay delL => Gain outGainL => revL;
inGain => Delay delR => Gain outGainR => revR;
delL => Gain fbL => delL; 1.0 :: second => delL.max => delL.delay;
delR => Gain fbR => delR; 2.0 :: second => delR.max => delR.delay;
0.0 => float delTarg => inGain.gain => fbL.gain => fbR.gain;

for (0 => int i;i < N; i++) {
    s[i] => outMix;
    s[i] => inGain;  // feed these babies to the delays too
    s[i] => sGains[i];
    if (i % 3 == 2) sGains[i] => sparkleVerbL;
    else if (i % 3 == 1) sGains[i] => sparkleVerbR;
    else { 
        sGains[i] => sparkleVerbL;
        sGains[i] => sparkleVerbR;
    }
    0.0 => s[i].gain;
    0.0 => sGains[i].gain;    
    funFreq*(harmStart+i) => freqs[i] => s[i].freq;
    (s[i].freq() / 44100 * 4096) $int => bins[i];
//    <<< bins[i] >>>;
}

spork ~ smoothStuff();

YMAX => y;
updatePhysics();

Machine.add("Drone.ck") => int drn;
score.name("");
score.setImage("LOrXScore6a.png");
0.1 :: second => now;
score.setImage("LOrXScore6b.png");
0.1 :: second => now;
score.setImage("LOrXScore6c.png");
0.1 :: second => now;
score.setImage("LOrXScore6d.png");
score.unsetImage();
score.name("OK, here you are at the last section(s).\nTilt forward/back does the same thing.\nYou're gonna do ryhthmic stuff with the ball mostly in the center\nTilt forward if you hear feedback, \nlet it clear, then back to ball in center, but keep singing!");
3.0 :: second => now;
score.name("");
1 => int notDone;

Hid kb; HidMsg kbmsg;
kb.openKeyboard(0);

fun void waitForSpacebar() {
    1 => int noSpace;
    while (noSpace)  {
        kb => now;
        while (kb.recv(msg))  {
            if (msg.type == Hid.BUTTON_DOWN 
                     && msg.ascii==32) 0 => noSpace;
        }
    }
    return;
}

spork ~ doSections();

fun void doSections()  {
    score.size(600,250);
    score.setImage("LOrXScore6a.png");  // Fem/Male LO--ks
    10.0 :: second => now;
    score.unsetImage();
    score.name("Leaders hang here, tilted back LOrX captured\n\nOthers hang here, tilted forward,\n\nuntil conductor gives\n\ndownbeat for spacebar");
    waitForSpacebar();
    score.name("");
    score.setImage("LOrXScore6b.png");  // aeterna, perpetua
    30.0 :: second => now;
    score.setImage("LOrXScore6c.png");  // perpetua, perPEtua
    40.0 :: second => now;
    1.0 => fftGain;
    capButt.name("[Full Sparkles]                    Full Loop/Delay Capture Position                    [No Sparkles]");
    score.setImage("LOrXScore6d.png");  // LO with Sparkles
    XMAX/2 => x;
    YMAX => y;
    0.0 => vx => ax;
    0.0 => vy => ay;
    40.0 :: second => now;
    score.unsetImage();
    score.name("OK, Sing an F or C and tilt forward and extremely to the right"); 
    while (notDone & (endButt.state()==0))  {
        0.05 :: second => now;
    }
    0 => notDone;
    1 => endButt.state;
}

while (notDone)	{
    updatePhysics();
//    XMAX/2 => x;
    y / YMAX => tiltTarg; // inGain.gain;
    1024 :: samp => now;		// Hop size
    fft.upchuck() @=> blob;		// Compute and
    blob.fvals() @=> float mag_spec[];	//     store spectrum
    for (0 => int i; i < N; i++) {
        if (mag_spec[bins[i]] > (targs[i]*0.5))  {  // "attack" phase
            (targs[i]*0.8) + (mag_spec[bins[i]]*0.2) => targs[i];
            freqs[i]*freqMult => s[i].freq;
            0.0 => sGains[i].gain;    
        }
        else {
            if (Std.rand2(0,4) == 0) {
                1 +=> sbins[i];
                1.0 => sGains[i].gain;
                if (sbins[i] < N) {  // up by harmonics at first
                    (funFreq*harmStart)+(funFreq * sbins[i]) => s[i].freq;
                }
                else {   // then up by some whole steps
                    s[i].freq() * Math.pow(1.12246,Std.rand2(1,3)) => float temp2;
                    if (temp2 < 22050)  {
                        0.9 * targs[i] => targs[i]; // fade out
                        temp2 => s[i].freq;
                    }
                    else 0.0 => targs[i];
                }
            }
        }
    }
    if (checkEnd()) 1 => endButt.state;
    if (endButt.state()) 0 => notDone;
    if (score.state()) {
        0 => endButt.state;
        0 => notDone;
        Machine.remove(drn);
    }
}

// clean up some of our mess
fft =< blackhole;
sparkleVerbL =< revL;
// sparkleVerbL =< sparkleVerbR;
sparkleVerbR =< revR;
// sparkleVerbR =< sparkleVerbL;
for (0 => int i;i < N; i++) {
    s[i] =< outMix;
    s[i] =< inGain;
    s[i] =< sGains[i];
    0.0 => sGains[i].gain;
}
0.0 => LL.gain => LR.gain => RR.gain => RL.gain;
0.0 => fbL.gain => fbR.gain;
0.0 => inGain.gain;

if (endButt.state())  {
    spork ~ rampDown();
    Machine.add("Drone.ck");
    score.unsetImage();
    score.name("OK!\n\nYou've done it!\n\nWait for things to fade...\n\nYou'll hear some Drones"); 
    4.0 :: second => now;
    Machine.add("Drone2.ck");
    score.name("Wait for things to fade...\n\nYou'll hear another Drone"); 
    5.0 :: second => now;
    Machine.add("Drone3.ck");
    score.name("OK!\n\nAlmost over now.\n\nYou'll hear a last big low Drone\n\nThen you'll hear some sparkles, fading, ...\n\nThen relax, and bow with all your fellow singers!"); 
    20.0 :: second => now;
}

myWinder.destroy();

fun void rampDown()  {
    revL.gain() => float temp;
    while (temp > 0.001)  {
        0.999 * temp => temp;
        temp => revL.gain => revR.gain;
    }
}

fun void smoothStuff()  {
    float temp;
    while (notDone)  {
        0.005 :: second => now;
        inGain.gain() => temp;
        temp*0.99 + tiltTarg*0.01 => temp => inGain.gain;        
        (1.0 - temp) => temp;
        temp => outGainL.gain => fbL.gain;
        temp => outGainR.gain => fbR.gain;
        temp*fftGain => fftIn.gain;
        3.0 * (1.0 - (x/XMAX)) => sinesGain;        
         for (0 => int i; i < N; i++) {
            targs[i]*0.985 => targs[i];
            sinesGain * targs[i] => s[i].gain;
        }
    }
}
 
 // Physics and stuff
 fun void updatePhysics() {
     hi.read( 9, 0, msg );
     SENSEX*msg.x*0.005 => ax;
     -SENSEY*msg.y*0.005 => ay;
     ((YMAX/2+40) - y) * 0.002 +=> ay;  // new for this section 
     (XMAX/2 - x) * 0.002 +=> ax;       // "gravity" toward center
     vx*DAMP + ax => vx; 
     x + vx => x; 
     if (x > XMAX) {  XMAX => x; -vx => vx;  }
     if (x < 0) {  0 => x; -vx => vx; }
     vy*DAMP + ay => vy; 
     y + vy => y;
     if (y > YMAX) { YMAX => y;  -vy => vy; }
     if (y < 0) {   0 => y;  -vy => vy; }
     dude.position(x,y);
 }    
 
fun int checkEnd()  {
     if (x > endButt.x() & y > endButt.y()) return 1;
     else return 0;
}
 
// Setup routines moved down here...
// fun void ditchIt()  { //  clean up with extreme predjudice
//     10 => Section;
//     myWinder.destroy();
//     Machine.remove(myDrone);
//     me.exit();
// }
 
 fun void getConfig()  {
     config.open( "CONFIG.txt", FileIO.READ );
     if (config.good())  {
         string in,token,value;
         StringTokenizer tok;
         config.readLine() => in; in => tok.set;
         tok.next(token); tok.next(value);
         Std.atof(value) => SENSEX;
         config.readLine() => in; in => tok.set;
         tok.next(token); tok.next(value);
         Std.atof(value) => SENSEY;
         config.close();
     }
     else {
         <<< "Need a CONFIG.txt file!!" >>>;
         me.exit();
     }
     <<< SENSEX, SENSEY >>>;
 }    
 
fun void doGUI()  {
     myWinder.size(600,600);
     myWinder.name("LOrX Aeterna Section 6 (P. Cook, PLOrk, April 2012)");
     score.size(600,120);
     score.toggleType(); score.position(0,240);
     myWinder.addElement(score);
     capButt.size(600,80); capButt.position(0,0);
     capButt.name("Full Loop/Delay Capture Position");
     myWinder.addElement(capButt);
     endButt.size(100,100); endButt.position(XMAX-30,YMAX-30);
     endButt.toggleType(); endButt.name("End Piece"); myWinder.addElement(endButt);
     dude.color(1); dude.light();
     myWinder.addElement(dude);
     myWinder.display();
}
